/* ----------------------------------------------------- */
/* Buzzword Generator                                    */
/* Dave MacLeod <davmac@netcomuk.co.uk>                  */
/*                                                       */
/* This app loads arrays with industry standard bullshit */
/* and then loops round generating meaningless babble    */
/* (as championed by consultancies the world over) by    */
/* choosing a word at random from each of the arrays.    */
/*                                                       */
/* I've used the source code from "Money" as a template, */
/* along with bits chopped out of the examples that come */
/* with GCC.                                             */
/* ----------------------------------------------------- */
/* v0.1     21/04/97    Creation                         */
/* ----------------------------------------------------- */
/* v0.2     27/04/97    Addition of "About box"          */
/*                      Copy text to clipboard           */
/* ----------------------------------------------------- */
/* v0.3     03/06/97    Fix randomisation bug            */
/* ----------------------------------------------------- */
/* v0.4     05/06/97    Add new words suggested by Peter */
/*                      Allwin.                          */
/* ----------------------------------------------------- */
/* v0.5     05/06/97    Add new words suggested by       */
/*                      Clym_Escudero@idx.com            */
/* ----------------------------------------------------- */
/* v0.6     26/09/97    Ported to Amiga by               */
/*                      newlook@ameritech.net            */
/* ----------------------------------------------------- */

#include <exec/types.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>

#define MaxE1        58
#define MaxE2        63
#define MaxE3        65
#define MaxC1        19
#define MaxC2        18
#define MaxC3        22

/* ----------------------------------------------------- */
/* Global Variables                                      */
/* ----------------------------------------------------- */

char Word1[MaxE1][MaxC1] =
{
  "Exclusive","Total","Fundamental","Phased","Integrated","Object-based","Devolved","Distributed",
  "Right-sized","Decentralized","Centralized","Ameliorated","Digitized","Networked","Focused",
  "Synergized","Polarised","Advanced","Assimilated","Optional","Synchronised","Compatible",
  "Function-based","Future-proofed","Managed","Organised","Up-sized","Down-sized","Mandatory",
  "Customer-focused","Business-focused","Profit-focused","Standalone","Organic","Quality-focused",
  "Secured","Extended","Cloned","Balanced","Reverse-Engineered","Syngergistic","Vision-oriented",
  "Enterprise-wide","De-engineered","Cross-group","Re-engineered","Open-architected","Front-line",
  "Optimized","Grass-roots","Horizontal","Multi-tiered","Team oriented","Face to face","Versatile",
  "Progressive","Persevering"
};

char Word2[MaxE2][MaxC2] =
{
  "client-server","didactic","radial","user-facing","eco-centric","uniform","composite","holistic",
  "stable","coherent","discrete","heuristic","hybrid","modular","optimal","homogeneous","incremental",
  "logistical","mobile","dynamic","executive","RAD/JAD","human-resource","empowering","vertical",
  "cohesive","systematic","responsive","reciprocal","transitional","human-resource","3rd generation",
  "4th generation","5th generation","scalable","fault-tolerant","WYSIWYG","local","national",
  "global","regional","neural","24hr","value-added","multimedia","systematic","maximizing",
  "clear-thinking","optimizing","motivating","well-modulated","fresh-thinking","keen","even-keeled",
  "upward-trending","methodical","tangible","bottom-line","actuating","analyzing","encompassing",
  "exuding","solution-oriented"
};

char Word3[MaxE3][MaxC3] =
{
  "hub","paradigm","concept","contingency","flexibility","methodology","project","definition",
  "projection","task-force","moderator","implementation","structure","ability","scenario",
  "challenge","solution","installation","knowledgebase","inheritance","throughput","approach",
  "alliance","implementation","data-warehouse","migration","interface","moratorium","parallelism",
  "monitoring","policy","capability","middleware","hardware","software","GUI","LAN/WAN","intranet",
  "toolset","product","support","help-desk","groupware","hit-squad","model","orchestration",
  "emulation","collaboration","focus group","success","conglomeration","attitude","pricing Structure",
  "workforce flexibility","synergy","system engine","alliance","utilization","GUI","open architecture",
  "open system","initiative","knowledge user","superstructure","frame"
};

/* ----------------------------------------------------- */
/* RandN                                                 */
/*   This function generates a random number between 0   */
/*   and MaxNo                                           */
/* Parms                                                 */
/*   MaxNo - Maximum number to be returned               */
/* Returns                                               */
/*   A random integer                                    */
/* ----------------------------------------------------- */

USHORT RandN(int MaxNo)
{
  srand(time(NULL));
  return((USHORT)(((USHORT)rand() * (USHORT)MaxNo) / (USHORT)RAND_MAX));
}

/* ----------------------------------------------------- */
/* DisplayWord                                           */
/*   This function wallops the buzzword out onto the     */
/*   screen.                                             */
/* Parms                                                 */
/*   None                                                */
/* Returns                                               */
/*   Nowt                                                */
/* ----------------------------------------------------- */

void DisplayWord(void)
{
  char tmp1[MaxC1];
  char tmp2[MaxC2];
  char tmp3[MaxC3];
  char tmp[MaxC1+MaxC2+MaxC3+3];

  strcpy(tmp1,Word1[RandN(MaxE1)]);
  strcpy(tmp2,Word2[RandN(MaxE2)]);
  strcpy(tmp3,Word3[RandN(MaxE3)]);

  strcpy(tmp,tmp1);
  strcat(tmp," ");
  strcat(tmp,tmp2);
  strcat(tmp," ");
  strcat(tmp,tmp3);
  printf("%s\n",tmp);
}

int main(int argc, char **argv)
{
   DisplayWord();
   return 0;
}
